<template>
  <div class="principal">
    <div class="row">
      <h2>Candidatos</h2>
      <button
        id="submit"
        type="button"
        class="btn btn-success"
        data-toggle="modal"
        data-target="#exampleModal"
      >Inscrever candidato</button>
    </div>

      <div
      class="modal fade"
      id="exampleModal"
      tabindex="-1"
      role="dialog"
      aria-labelledby="exampleModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Novo candidato</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Fechar">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <form @submit.prevent="cadastrar_candidato">
              <div class="form-group">
                <label for="recipient-name" class="col-form-label" >Nome:</label>
                <input type="text" class="form-control" id="recipient-name" v-model="candidato.nome" />
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label">E-mail:</label>
                <input type="text" class="form-control" id="recipient-name" v-model="candidato.email"/>
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label">Atividade</label>
                <input type="text" class="form-control" id="recipient-name" v-model="candidato.email"/>
              </div>
              <div class="form-group">
                <label for="recipient-name" class="col-form-label">Evento</label>
                <input type="text" class="form-control" id="recipient-name" v-model="candidato.email"/>
              </div>
              
              <div class="form-row">
                <div class="form-group col-md-4">
                  <label for="recipient-name" class="col-form-label">Matrícula:</label>
                  <input type="text" class="form-control" id="recipient-name" v-model="candidato.matricula"/>
                </div>
                <div class="form-group col-md-8">
                  <label for="recipient-name" class="col-form-label">Evento:</label>
                  <select name id class="form-control" v-model="candidato.curso">
                    <option selected>SELECIONE</option>
                    <option v-for="curso of cursos" :key="curso.id">{{ curso.descricao }}</option>
                  </select>
                </div>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Fechar</button>
                <button type="submti" class="btn btn-primary" >Enviar</button>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>

  <div class="table-responsive">
    <table class="table table-sm table-striped">
  <thead>
    <tr>
      <th></th>
      <th scope="col">Nome</th>
      <th scope="col">E-mail</th>
      <th scope="col">Matrícula</th>  
      <th scope="col">Ações</th>
    </tr>
  </thead>
  <tbody>
    <tr v-for="candidato in candidatos" :key="candidato.id">
      <td><a class="btn"
        data-toggle="modal"
        data-target="#exampleModal"><i class="fas fa-search"></i></a></td>
      <td>{{candidato.nome}}</td>
      <td>{{candidato.email}}</td>      
      <td>{{candidato.matricula}}</td>
      <td>
        <button @click="editar(candidato)" data-toggle="modal" data-target="#exampleModal" type="button" class="btn btn-primary"><i class="fas fa-edit"></i></button>   
        <button @click="remover(candidato)" type="button" class="btn btn-danger"><i class="fas fa-trash"></i></button> 
      </td>
    </tr>
  </tbody>
</table>
</div>   
  
  </div>
</template>

<script>
import curso from "../services/cursos";
import Candidato from '../services/candidatos'
import axios from 'axios'

export default {
  name: "Candidato",
  data() {
    return {
      candidato: {
        id: '',
        nome: '',
        email: '',
        matricula: '',
        curso: '',
      },
      // inscricao: {
        
      // }
      cursos: [],
      candidatos: [],
    };
  },
  mounted() {
    this.listar_candidatos()
    this.listar_cursos()
  },
  methods: {
    listar_cursos() {
      curso.listar_cursos().then(resp => {
        for (var curso of resp.data.results) {
          if (curso.modalidade == "Integrado" && curso.descricao.includes("João Pessoa")) {
            this.cursos.push(curso);
          }
        }
      });
    },

    listar_candidatos(){
      Candidato.listar().then(resp=> {
          this.candidatos = resp.data
        }
      )
    },

    cadastrar_candidato(){
      if(!this.candidato.id){
        Candidato.salvar(this.candidato).then(resposta => {
              axios.
              this.candidato = {}
              alert('Salvo com sucesso!!')
              this.listar_candidatos()
        })
      }else{
        Candidato.atualizar(this.candidato).then(resposta => {
          this.candidato = {}
          alert('Candidato Atualizado!')
          this.listar_candidatos()
        })
      }
          
    },

    editar(candidato){
        this.candidato = candidato
    },

    remover(candidato){
        if(confirm('Deseja excluir o candidato?')){
          Candidato.apagar(candidato).then(resposta => {
            this.candidato = {}
            this.listar_candidatos()  
          })
        }
    }

  }
};
</script>

<style scoped>
#submit {
  margin-left: auto;
  margin-bottom: auto;
  margin-top: auto;
}
.row {
  border-bottom: solid 1px #000;
  margin-top: 15px;
}
.table-responsive{
    margin-top: 20px;
}
</style>